// Hlavn program
// Soutc . 11

// Soubory : mcr11_main.pas, mcr11_prog.pas,
//           mcr11_prog.pas, mcr11_main.dfm,
//           mcr11.dpr

unit mcr11_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Outline;

type
  TMainForm = class(TForm)
    Outline : TOutline;
    But_Add    : TButton;
    But_Remove : TButton;
    But_Load   : TButton;
    OpenDialog : TOpenDialog;
    But_Synchronize : TButton;
    Button1: TButton;
    procedure But_AddClick(Sender: TObject);
    procedure But_RemoveClick(Sender: TObject);
    procedure But_LoadClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ZverejniRodokmen; // Vykresli rodokmen na formul
  end;

  TIDString    = String[10]; // Typ pro ID
  TJmenoString = String[32]; // Typ pro Jmeno, Prijmeni

  TOsoba = record            // Zznam o jedn osob
    Id       : TIDString;
    Jmeno    : TJmenoString;
    Prijmeni : TJmenoString;
    Pohlavi  : Char;
    Narozeni : Integer;
    Umrti    : Integer;
    Matka    : TIDString;
    Otec     : TIDString;
  end;

  TRodokmen = record
    Osoby : Array of TOsoba;
  end;

var
  MainForm : TMainForm;
  Rodokmen : TRodokmen;

  Counter  : Integer = 1; // Pro pidvn novch osob

implementation

uses mcr11_prog;

{$R *.DFM}

function BezpecnyStrToInt( Str : String ) : Integer;
begin
  try
    Result := StrToInt(Str);
  except
    Result := -1;
  end
end;

procedure PridejDoRodokmenu( ID : TIDString;
                             Jmeno, Prijmeni : TJmenoString;
                             Pohlavi : Char;
                             Narozeni, Umrti : Integer;
                             Matka, Otec : TIDString );
var
  i : Integer;
begin
  i := Length(Rodokmen.Osoby)+1;
  SetLength(Rodokmen.Osoby, i );
  i := i-1;

  Rodokmen.Osoby[i].Id := Id;
  Rodokmen.Osoby[i].Jmeno := Jmeno;
  Rodokmen.Osoby[i].Prijmeni := Prijmeni;
  Rodokmen.Osoby[i].Pohlavi := Pohlavi;
  Rodokmen.Osoby[i].Narozeni := Narozeni;
  Rodokmen.Osoby[i].Umrti := Umrti;
  Rodokmen.Osoby[i].Matka := Matka;
  Rodokmen.Osoby[i].Otec := Otec;
end;

function IDOsobyNaIndexOsoby( ID : TIDString ) : Integer;
var
  i, Delka : Integer;
begin
  Result := -1;
  Delka := Length(Rodokmen.Osoby);
  For i := 0 to (Delka-1) do
   if Rodokmen.Osoby[i].Id = Id then begin
     Result := i;
     EXIT;
   end;
end;

function OdeberZRodokmenu( ID : TIDString ) : Boolean;
var
  i, j  : Integer; // Pro cykly
  Delka : Integer; // Delka dyn. pole osob
begin
  Result := False;
  Delka := Length(Rodokmen.Osoby);

  i := IDOsobyNaIndexOsoby(ID);

  if (i <> -1) then
  if (Rodokmen.Osoby[i].Id = Id) then begin

    For j := i to (Delka-2) do
      Rodokmen.Osoby[j] := Rodokmen.Osoby[j+1];

    SetLength(Rodokmen.Osoby, Delka-1 );

    Result := True;
  end;
end;

function JeDite( Index : Integer ) : Boolean;
begin
  Result := False;
  if (Rodokmen.Osoby[Index].Matka <> '')
  or (Rodokmen.Osoby[Index].Otec <> '') then Result := True;
end;

function KohoDite( Index : Integer ) : Integer;
begin
  if (Rodokmen.Osoby[Index].Matka <> '' ) then
    Result := IDOsobyNaIndexOsoby(Rodokmen.Osoby[Index].Matka)
  else
    Result := IDOsobyNaIndexOsoby(Rodokmen.Osoby[Index].Otec)
end;

function HledejID( ID : TIDString ) : Boolean;
var
  i, Delka : Integer;
begin
  Result := False;
  Delka := Length(Rodokmen.Osoby);
  For i := 0 to (Delka-1) do begin
    if Rodokmen.Osoby[i].ID = ID then begin
      Result := True;
      EXIT;
    end;
  end;
end;

procedure TMainForm.But_AddClick(Sender: TObject);
var
  Id       : String;
  Jmeno    : String;
  Prijmeni : String;
  Pohlavi  : String;
  NarozeniStr : String;
  Narozeni    : Integer;
  UmrtiStr : String;
  Umrti    : Integer;
  Matka    : String;
  Otec     : String;
begin
  // Hled jedinen ID
  while HledejID( 'I'+IntToStr(Counter) ) do Inc(Counter);

  // Zept se na ketn jmno
  while (Length(Jmeno) = 0) or (Length(Jmeno) > 32) do
    InputQuery('Zadejte kestn jmno : ','Jmno osoby : ', Jmeno );

  // pjmen
  while (Length(Prijmeni) = 0) or (Length(Prijmeni) > 32) do
    InputQuery('Zadejte pjmen : ','Pjmen osoby : ', Prijmeni );

  // pohlav
  while (Pohlavi <> 'M') and (Pohlavi <> 'Z') do
  begin
    InputQuery('Zadejte pohlav : ','Pohlav ("M"=Mu, "Z"=ena) : ', Pohlavi );
    Pohlavi := UpperCase(Pohlavi);
  end;

  Narozeni := -1;
  while (Length(NarozeniStr) <> 4) or (Narozeni = -1) do begin
    InputQuery('Zadejte rok narozen : ','Rok narozen : ', NarozeniStr );
    Narozeni := BezpecnyStrToInt(NarozeniStr);
  end;

  Umrti := -1;

  while (Length(UmrtiStr) <> 4) or (Umrti = -1) or (Umrti = -2) do begin
    InputQuery('Zadejte rok umrt : ','Rok umrt : ', UmrtiStr );
    if (Length(UmrtiStr) = 0) then Umrti := -2
      else Umrti := BezpecnyStrToInt(UmrtiStr);
  end;

  InputQuery('Zadejte ID matky : ','ID matky : ', Matka );
  InputQuery('Zadejte ID otce : ','ID otce : ', Otec );

  while (Length(UmrtiStr) <> 4) or (Umrti = -1) do begin
    InputQuery('Zadejte ID Matky : ','ID Matky : ', Matka );
    Umrti := BezpecnyStrToInt(UmrtiStr);
  end;

  PridejDoRodokmenu( ID, Jmeno, Prijmeni, Pohlavi[1], Narozeni, Umrti, Matka, Otec );
  ZverejniRodokmen;
end;



procedure TMainForm.But_RemoveClick(Sender: TObject);
var
  ID : String;
begin
  InputQuery('Odebrn osoby z rodokmenu','ID osoby : ',ID);
  if not OdeberZRodokmenu( ID ) then ShowMessage('Bohuel, nezadali jste platn ID.');
  ZverejniRodokmen;
end;

procedure TMainForm.ZverejniRodokmen;
var
  i     : Integer;
  Delka : Integer;

  function Vypis( Osoba : TOsoba ) : String;
  begin
    Result := Osoba.ID;
    Result := Result+' - '+Osoba.Jmeno;
    Result := Result+' '+Osoba.Prijmeni;
    Case Osoba.Pohlavi of
      'M' : Result := Result+' [mu]';
      'Z' : Result := Result+' [ena]';
    end;
    Result := Result+' (Narozeni:'+IntToStr(Osoba.Narozeni);
    if (Osoba.Umrti <> -2) then
      Result := Result+', Umrt :'+IntToStr(Osoba.Umrti)+')'
    else
      Result := Result+')';

    if Osoba.Matka <> '' then
      Result := Result + ' [Matka: '+Osoba.Matka+']';

    if Osoba.Otec <> '' then
      Result := Result + ' [Otec: '+Osoba.Otec+']';
  end;

  procedure Pridej;
  begin
    if NOT JeDite(i) then
      OutLine.Add( OutLine.ItemCount, Vypis(Rodokmen.Osoby[i]) )
    else
      OutLine.AddChild( OutLine.ItemCount, Vypis(Rodokmen.Osoby[i]) );
  end;

begin
  Delka := Length(Rodokmen.Osoby);
  OutLine.Lines.Clear;

  For i := 0 to (Delka-1) do
    OutLine.Add( OutLine.ItemCount, Vypis(Rodokmen.Osoby[i]) ); //  Pridej;
end;


procedure TMainForm.But_LoadClick(Sender: TObject);
const
  Chars = ['0'..'9','a'..'z','A'..'Z',
           '','','','','','','','','','','','','','','',
           '','','','','','','','','','','','','','','', '-' ];
var
  FileName : String;
  RodoFile : TStrings;
  Zacatek, Delka, i : Integer;
  Slovo, VSlovo : String;

  function PrectiSlovo : String;
  begin
    Result  := '';
    Zacatek := i;
    while not (RodoFile.Text[i] in Chars) and (i <= Delka) do Inc(i);
    while (RodoFile.Text[i] in Chars) and (i <= Delka) do Inc(i);
    Result  := Copy( RodoFile.Text, Zacatek, i-Zacatek );
    if Result <> '' then if Result[1] = '>' then Delete(Result,1,1);
  end;


  function PrectiSlovoVZavorkach : String;
  begin
    Result := '';
    while (RodoFile.Text[i] <> '<') and (i <= Delka) do Inc(i);
    if (RodoFile.Text[i] = '<') then begin
      Zacatek := i;
      while (RodoFile.Text[i] <> '>') and (i <= Delka) do Inc(i);
      Result := Copy( RodoFile.Text, Zacatek, i-Zacatek );
      if Result[1]              = '<' then Delete( Result,              1, 1 );
      if Result[Length(Result)] = '>' then Delete( Result, Length(Result), 1 );
    end;
    Result := UpperCase(Result);
  end;

  procedure NactiOsobu;
  var
    OSlovo : String;
    OK     : Boolean;
    NovaOsoba : TOsoba;
  begin
    OK := True;
    NovaOsoba.Jmeno    := '';
    NovaOsoba.Prijmeni := '';
    NovaOsoba.Pohlavi  := 'N';
    NovaOsoba.Narozeni := -1;
    NovaOsoba.Umrti    := -2;
    NovaOsoba.Matka    := '';
    NovaOsoba.Otec     := '';
    repeat
      OSlovo := PrectiSlovoVZavorkach;
      if OSlovo = 'ID' then begin // Zjistme ido
        NovaOsoba.ID := PrectiSlovo;
      end;
      if OSlovo = 'JMENO' then begin // Zjistme jmno
        NovaOsoba.Jmeno := PrectiSlovo;
      end;
      if OSlovo = 'PRIJMENI' then begin // Zjistme pjemn
        NovaOsoba.Prijmeni := PrectiSlovo;
      end;
      if OSlovo = 'POHLAVI' then begin // Zjistme pohlav
        Slovo := PrectiSlovo;
        if Length(Slovo) = 1 then NovaOsoba.Pohlavi := UpCase(Slovo[1])
                             else OK := False;
      end;
      if OSlovo = 'NAROZENI' then begin // Zjistme rok narozen
        NovaOsoba.Narozeni := BezpecnyStrToInt(PrectiSlovo);
      end;
      if OSlovo = 'UMRTI' then begin // Zjistme rok mrt
        NovaOsoba.Umrti := BezpecnyStrToInt(PrectiSlovo);
      end;
      if OSlovo = 'MATKA' then begin // Zjistme matku
        NovaOsoba.Matka := PrectiSlovo;
      end;
      if OSlovo = 'OTEC' then begin // Otce
        NovaOsoba.Otec := PrectiSlovo;
      end;
    until (OSlovo = '/OSOBA') or (OSlovo = ''); // Dokud neskon informace o osob
    if NovaOsoba.Id = '' then OK := False; // Pokud nem id tak nen v pdku
    if HledejID( NovaOsoba.ID ) then OK := False; // Pokud ji najde v seznamu osobu
                                                  // se setjnm ID
    if OK then begin // Pokud ve je OK tak
      SetLength(Rodokmen.Osoby,Length(Rodokmen.Osoby)+1);
      Rodokmen.Osoby[Length(Rodokmen.Osoby)-1] := NovaOsoba;
    end;
  end;

begin
  if OpenDialog.Execute then // Pokud byl vybrn njak soubor
  begin
    ProgForm.Show;
    ProgForm.Gauge.Progress := 0;

    FileName := OpenDialog.FileName;

    SetLength(Rodokmen.Osoby,0);

    RodoFile := TStringList.Create;
    RodoFile.LoadFromFile(FileName); // Nateme si informace o rodokmeni

    Delka := Length(RodoFile.Text);

    if (Delka = 0) then begin
      ShowMessage('Vybrali jste przdn soubor !');
      EXIT;
    end;

    i := 1;
    VSlovo := PrectiSlovoVZavorkach; // Precte prvn slovo v '< >' - mlo by bt
                                     // "RODOKMEN"

    // patn zatek
    if VSlovo <> 'RODOKMEN' then begin
      ShowMessage('patn zatek souboru !');
      EXIT;
    end;

    repeat
      VSlovo := PrectiSlovoVZavorkach;
      if VSlovo = 'OSOBA' then NactiOsobu;
      ProgForm.Gauge.Progress := Round((100/Delka)*i);
      Application.ProcessMessages;
      if StornoClick then begin
        SetLength(Rodokmen.Osoby,0);
        EXIT;
      end;
    until (VSlovo = '\RODOKMEN') or (VSlovo = '');
    // Dokud nen konec souboru nebo nen ukoneno \Rodokmen tak te informace
    // o osobch

    RodoFile.Free;

    ProgForm.Gauge.Progress := 100;
    ProgForm.Hide;

    ZverejniRodokmen;
  end;
end;

end.
